;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                       ;;
;;;                					                  ;;
;;;                     University of Nairobi, Kenya                      ;;
;;;                       Copyright (c) 2004                              ;;
;;;                        All Rights Reserved.                           ;;
;;;                                                                       ;;
;;;  Permission is hereby granted, free of charge, to use and distribute  ;;
;;;  this software and its documentation without restriction, including   ;;
;;;  without limitation the rights to use, copy, modify, merge, publish,  ;;
;;;  distribute, sublicense, and/or sell copies of this work, and to      ;;
;;;  permit persons to whom this work is furnished to do so, subject to   ;;
;;;  the following conditions:                                            ;;
;;;   1. The code must retain the above copyright notice, this list of    ;;
;;;      conditions and the following disclaimer.                         ;;
;;;   2. Any modifications must be clearly marked as such.                ;;
;;;   3. Original authors' names are not deleted.                         ;;
;;;   4. The authors' names are not used to endorse or promote products   ;;
;;;      derived from this software without specific prior written        ;;
;;;      permission.                                                      ;;
;;;                                                                       ;;
;;;  THE UNIVERSITY OF NAIROBI AND THE CONTRIBUTOR OUTSIDE ECHO           ;;
;;;  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      ;;
;;;  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   ;;
;;;  SHALL THE UNIVERSITY OF NAIROBI  OR OUTSIDE ECHO       BE LIABLE     ;;
;;;  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    ;;
;;;  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   ;;
;;;  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          ;;
;;;  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       ;;
;;;  THIS SOFTWARE.                                                       ;;
;;;                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;									  ;;
;;;  Authors: Mucemi Gakuru, Fredrick Iraki and Kamanda Ngugi	          ;;
;;;  Duration Data: A hand specified tree to predict zcore durations      ;;
;;;  Customized for: UON_swahili_kw_clunits                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set! UON_swahili_kw::zdur_tree 
 '
   ((R:SylStructure.parent.R:Syllable.p.syl_break > 1 ) ;; clause initial
    ((1.5))
    ((R:SylStructure.parent.syl_break > 1)   ;; clause final
     ((1.5))
     ((1.0)))))

(set! UON_swahili_kw::phone_durs
'(
   (# 0.0 0.250)

   (a 0.0 0.100)
   (e 0.0 0.100)
   (i 0.0 0.100)
   (o 0.0 0.100)
   (u 0.0 0.100)

   (a1 0.0 0.110)
   (e1 0.0 0.110)
   (i1 0.0 0.110)
   (o1 0.0 0.110)
   (u1 0.0 0.110)

   (a2 0.0 0.150)
   (e2 0.0 0.150)
   (i2 0.0 0.150)
   (o2 0.0 0.150)
   (u2 0.0 0.150)

   (b 0.0 0.100)
   (c 0.0 0.060)
   (ch 0.0 0.135)
   (d 0.0 0.060)
   (dh 0.0 0.135)
   (f 0.0 0.100)
   (gh 0.0 0.100)
   (g 0.0 0.080)
   (h 0.0 0.150)
   (j 0.0 0.120)
   (k 0.0 0.100)
   (kh 0.0 0.135)
   (l 0.0 0.080)
   (m2 0.0 0.170)
   (m1 0.0 0.100)
   (m 0.0 0.070)
   (n2 0.0 0.170)
   (n1 0.0 0.100)
   (n 0.0 0.080)
   (ny 0.0 0.110)
   (ng 0.0 0.155)
   (ng1 0.0 0.135) 	;;ng'
   (p 0.0 0.100)
   (r 0.0 0.030)
   (s 0.0 0.100)
   (sh 0.0 0.135)
   (t 0.0 0.100)
   (th 0.0 0.100)
   (v 0.0 0.085)
   (w 0.0 0.085)
   (y 0.0 0.100)
   (z 0.0 0.100)
))

(provide 'UON_swahili_kw_durdata)
