;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                       ;;
;;;                					                  ;;
;;;                     University of Nairobi, Kenya                      ;;
;;;                       Copyright (c) 2004                              ;;
;;;                        All Rights Reserved.                           ;;
;;;                                                                       ;;
;;;  Permission is hereby granted, free of charge, to use and distribute  ;;
;;;  this software and its documentation without restriction, including   ;;
;;;  without limitation the rights to use, copy, modify, merge, publish,  ;;
;;;  distribute, sublicense, and/or sell copies of this work, and to      ;;
;;;  permit persons to whom this work is furnished to do so, subject to   ;;
;;;  the following conditions:                                            ;;
;;;   1. The code must retain the above copyright notice, this list of    ;;
;;;      conditions and the following disclaimer.                         ;;
;;;   2. Any modifications must be clearly marked as such.                ;;
;;;   3. Original authors' names are not deleted.                         ;;
;;;   4. The authors' names are not used to endorse or promote products   ;;
;;;      derived from this software without specific prior written        ;;
;;;      permission.                                                      ;;
;;;                                                                       ;;
;;;  THE UNIVERSITY OF NAIROBI AND THE CONTRIBUTOR OUTSIDE ECHO           ;;
;;;  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      ;;
;;;  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   ;;
;;;  SHALL THE UNIVERSITY OF NAIROBI  OR OUTSIDE ECHO       BE LIABLE     ;;
;;;  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    ;;
;;;  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   ;;
;;;  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          ;;
;;;  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       ;;
;;;  THIS SOFTWARE.                                                       ;;
;;;                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;									  ;;
;;;  Authors: Mucemi Gakuru, Fredrick Iraki and Kamanda Ngugi	          ;;
;;;  Lexicon, LTS and Postlexical rules for UON_swahili_kw_clunits        ;;
;;;  				                                          ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(define (UON_swahili_addenda)
  "(UON_swahili_addenda)
Basic lexicon should (must ?) have basic letters, symbols and punctuation."

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Pronunciation of letters in the Alphabet				  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(lex.add.entry '("0" nn (((z u) 0) ((f u2) 1) ((r i) 0))))
(lex.add.entry '("1" nn (((m o2) 1) ((j a) 0))))
(lex.add.entry '("2" nn (((m) 0) ((b i2) 1) ((l i) 0))))
(lex.add.entry '("3" nn (((t a2) 1) ((t u) 0))))
(lex.add.entry '("4" nn (((n2) 1) ((n e) 0))))
(lex.add.entry '("5" nn (((t a2) 1) ((n o) 0))))
(lex.add.entry '("6" nn (((s i2) 1) ((t a) 0))))
(lex.add.entry '("7" nn (((s a2) 1) ((b a) 0))))
(lex.add.entry '("8" nn (((n a2) 1) ((n e) 0))))
(lex.add.entry '("9" nn (((t i2) 1) ((s a) 0))))

(lex.add.entry '("a" nn (((a2 a) 0))))
(lex.add.entry '("b" nn (((b a) 0))))
(lex.add.entry '("c" nn (((s e2) 0))))
(lex.add.entry '("d" nn (((d a2) 0))))
(lex.add.entry '("e" nn (((e2) 0))))
(lex.add.entry '("f" nn (((f a2) 0))))
(lex.add.entry '("g" nn (((g a2) 0))))
(lex.add.entry '("h" nn (((h a2) 0))))
(lex.add.entry '("i" nn (((i2) 0))))
(lex.add.entry '("j" nn (((j a2) 0))))
(lex.add.entry '("k" nn (((k a2) 0))))
(lex.add.entry '("l" nn (((l a2) 0))))
(lex.add.entry '("m" nn (((m a2) 0))))
(lex.add.entry '("n" nn (((n a2) 0))))
(lex.add.entry '("o" nn (((o) 0))))
(lex.add.entry '("p" nn (((p a2) 0))))
(lex.add.entry '("q" nn (((k u2) 0))))
(lex.add.entry '("r" nn (((r a2) 0))))
(lex.add.entry '("s" nn (((s a2) 0))))
(lex.add.entry '("t" nn (((t a2) 0))))
(lex.add.entry '("u" nn (((u2) 0))))
(lex.add.entry '("v" nn (((v a2) 0))))
(lex.add.entry '("w" nn (((w a2) 0))))
(lex.add.entry  '("x" n (((e2) 0) ((k) 0) ((s) 0))))
(lex.add.entry '("y" nn (((y a2) 0))))
(lex.add.entry '("z" nn (((z a2) 0))))
(lex.add.entry 
 '("switzerland" n (((s w i2) 1) ((z e) 0) ((r) 0) ((l a) 0) ((a) 0) ((n) 0) ((d) 0))))
(lex.add.entry 
 '("computer" n (((k o) 0) ((m) 0) ((p i) 0) ((u) 0) ((t a) 0))))
(lex.add.entry 
 '("mucemi" n (((m u) 0) ((sh e) 0) ((m i) 0))))
(lex.add.entry 
 '("george" n (((j o2) 0) ((j i) 0))))
 (lex.add.entry 
 '("roselyne" n (((r o) 0) ((z e) 0) ((l i) 0) ((n) 0))))
(lex.add.entry 
 '("allan" n (((a) 0) ((l a) 0) ((n) 0))))
(lex.add.entry 
 '("Ayutthaya" n (((a) 0) ((y u) 0)((th a1) 1) ((y a) 0))))
(lex.add.entry 
 '("range" n (((r a) 0) ((n1) 1)((j i) 0))))
(lex.add.entry 
 '("rover" n (((r o1) 1) ((v a) 0))))
(lex.add.entry 
 '("ooh" n (((o1) 1) ((o) 0))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Pronounciation of Symbols * & % $ etc				  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(lex.add.entry 
 '("*" n (((n y) 0) ((t a) 0))))
(lex.add.entry 
 '("%" n (((a) 0) ((s i ) 0) ((l i ) 0) ((m i ) 1) ((a) 0))))
(lex.add.entry 
 '("&" n (((n a1) 1))))
(lex.add.entry 
 '("$" n (((d o1) 1) ((l a ) 0))))
(lex.add.entry 
 '("#" n (((n a ) 0) ((m) 0) ((b a) 0))))
(lex.add.entry 
 '("@" n (((k a) 0) ((t i1) 1) ((k a) 0))))
(lex.add.entry 
 '("+" n (((k u) 0) ((o) 0) ((ng e1) 1) ((z a) 0)) ((pos "K7%" "OA%" "T-%"))))
(lex.add.entry 
 '("^" n (((k a1) 1) ((r e t) 0)) ((pos "K6$"))))
(lex.add.entry 
 '("~" n (((t i1 l) 1) ((d e) 0)) ((pos "K6$"))))
(lex.add.entry 
 '("=" n (((s a) 0) ((w a) 0) ((s a1) 1) ((w a) 0))))
(lex.add.entry 
 '("/" n (((m) 1) ((g a1) 1) ((w o) 0))))  ;; $$$division, etc.
(lex.add.entry 
 '("\\" n (((b a1) 1) ((rr a) 1))))
(lex.add.entry 
 '("_" n (((m) 0) ((s) 0) ((t a1) 1) ((l i) 0) ((w a) 0) ((ch i1) 1) ((n i) 0)) ))
(lex.add.entry 
 '("|" n (((b a1) 1) ((rr a) 0))))
(lex.add.entry 
 '(">" n ((( k u) 0) ((b) 0) ((w a) 0) ((k u) 0) ((l i1) 1) ((k o) 0))))
(lex.add.entry 
 '("<" n (((ch a1) 1) ((ch e) 0))))
(lex.add.entry 
 '("[" n (((k i) 0) ((f u) 0) ((ng o) 0) ((m) 0) ((r a) 0) ((b a) 0) ((ch a) 0) ((k u) 0) ((f u) 0) ((ng u) 0) ((w a) 0))))
(lex.add.entry 
 '("]" n (((k i) 0) ((f u) 0) ((ng o) 0) ((m) 0) ((r a) 0) ((b a) 0) ((ch a) 0) ((k u) 0) ((f u) 0) ((ng a) 0))))
(lex.add.entry 
 '(" " n (((n a) 0) ((f a1) 1) ((s i) 0))))
(lex.add.entry 
 '("\t" n (((k u) 0) ((p a) 0) ((ng a) 0) ((k) 0) ((w a) 0) ((o) 0) ((r o) 0) ((th a) 0))))
(lex.add.entry 
 '("\n" n (((m) 0) ((s) 0) ((t a1) 1) ((l i) 0) ((m) 0) ((p) 0) ((y a) 0))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pronounciation of Punctuation etc				  ;
;; Basic punctuation must be in with nil pronunciation  		  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Basic punctuation must be in with nil pronunciation
(lex.add.entry '("." punc nil))
(lex.add.entry '("\'" punc nil))
(lex.add.entry '(":" punc nil))
(lex.add.entry '(";" punc nil))
(lex.add.entry '("," punc nil))
(lex.add.entry '("," punc nil))
(lex.add.entry '("-" punc nil))
(lex.add.entry '("\"" punc nil))
(lex.add.entry '("`" punc nil))
(lex.add.entry '("?" punc nil))
(lex.add.entry '("!" punc nil))
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Hand written letter to sound rules
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;  Function called when word not found in lexicon
(define (UON_swahili_lts_function word features)
  "(swahili_lts_function WORD FEATURES) Return pronunciation of word not in lexicon."
   (format stderr "failed to find pronunciation in Lexicon for %s\n" word)
   (let ((word (downcase word)))
	 (if (lts.in.alphabet word 'swahili)
	   (list word features
	 ;; This syllabification is almost certainly wrong for
	 ;; this language (its not even very good for English)
	 ;; but it will give you something to start off with
	 (lex.syllabify.phstress 
	    (lts.apply word 'swahili)))
	      (begin
	  	(format stderr "unpronouncable word %s\n" word)
	         '("haijulikani" nil ((( h a) 0) ((i) 0) ((j u) 0)  ((k a) 1) ((n i) 0))))))
)

(define (swahili_phstress word)
	;(print (word.features))
     (print word)
	;(print (item.name word))
     (print (item.features word))
	;(if (string-matches (item.feat word "punc") 	"[\.\?\!\,\;\:]+")
		;(begin
			;(print "here am present")
			;(print (word.feat word "punc"))
          ;)	
		;(print "not present")
	;)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Function Called When Word is Not Found in Lexicon			  ;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (swahili_lts word features)
  "(swahili_lts WORD FEATURES)
  	(print word)
        Using various letter to sound rules build a Swahili pronunciation of WORD."
  (let (phones syl stresssyl dword weakened)
    (if (lts.in.alphabet word 'UON_swahili)
	(set! dword (downcase word)))
    (set! phones (lts.apply dword 'UON_swahili))
    (set! syl (lts.apply phones 'swahili_syl))
    (set! stresssyl (lts.apply syl 'swahili.stress))
    ;(swahili_phstress features)
    (list word
	  nil
	  (swahili_brackets stresssyl)))
)

;; You may or may not be able to write a letter to sound rule set for
;; your language.  If its largely lexicon based learning a rule
;; set will be better and easier that writing one (probably).
(lts.ruleset
 UON_swahili
   (	;  Sets used in the rules
    (V a e i o u )
    (C b c d f g h j k l m n p r s t v w y z )
   )
 (
  ;; LTS rules 
  ;; map stressed phones to themselves only when desired

  ( [ a 1 ] = a1 )
  ( [ e 1 ] = e1 )
  ( [ i 1 ] = i1 )
  ( [ o 1 ] = o1 )
  ( [ u 1 ] = u1 )
  ( [ m 1 ] = m1 )
  ( [ n 1 ] = n1 )
  ( [ a 2 ] = a2 )
  ( [ e 2 ] = e2 )
  ( [ i 2 ] = i2 )
  ( [ o 2 ] = o2 )
  ( [ u 2 ] = u2 )
  ( [ m 2 ] = m2 )
  ( [ n 2 ] = n2 )

  ;; G2P

  ( [ a ] = a )
  ( [ e ] = e )
  ( [ i ] = i )
  ( [ o ] = o )
  ( [ u ] = u )
  ( [ b ] = b )
  ( [ c h ] = ch )
  ( [ d h ] = dh )
  ( [ d ] = d )
  ( [ f ] = f )
  ( [ n g 1 ] = ng1 )
  ( [ n g "'" ] = ng1 )
  ( [ n g ] = ng )
  ( [ g h ] = gh )
  ( [ g ] = g )
  ( [ s h ] = sh ) 
  ( [ t h ] = th )   
  ( [ h ] = h )
  ( [ j ] = j )
  ( [ k h ] = kh )
  ( [ k ] = k )
  ( [ l ] = l )
  ( [ m ] = m )
  ( [ n y ] = ny )
  ( [ n ] = n )
  ( [ p ] = p )
  ( [ r ] = r )
  ( [ s ] = s )   
  ( [ t ] = t )
  ( [ v ] = v )
  ( [ w ] = w )
  ( [ y ] = y )
  ( [ z ] = z )
  ( [ ? ] =   )

  ;; Take care of c, x and q found on their own

  ( [ c ] = k )
  ( [ x ] = kh )
  ( [ q ] = k )
 
  )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Swahili sylabification by rewrite rules
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(lts.ruleset
   swahili_syl

    (   (V a1 e1 i1 o1 u1 a e i o u a2 e2 i2 o2 u2)
        (C b ch d dh f g gh h j k kh l m m1 m2 n n1 n2 ng ng1 ny p r s sh t th v w y z )
        (CG b ch d dh f g gh h j k kh l m m1 m2 ny p r s sh t th v w y z )
        (CH b f h j l m m1 n n1 n2 ng ng1 ny p r v w y z )
     )

   ;; Rules will add - at syllable boundary

   (
      ;; If there is a vowel before any phone its a syl break
      ;; triptongs and diptongs do not exists in Kiswahili
 
      (  V  [ a ]  = - a )
      (  V  [ i ]  = - i )
      (  V  [ u ]  = - u )
      (  V  [ e ]  = - e )
      (  V  [ o ]  = - o )
      (  V  [ a1 ]  = - a1 )
      (  V  [ e1 ]  = - e1 )
      (  V  [ i1 ]  = - i1 )
      (  V  [ o1 ]  = - o1 )
      (  V  [ u1 ]  = - u1 )
      (  V  [ a2 ]  = - a2 )
      (  V  [ e2 ]  = - e2 )
      (  V  [ i2 ]  = - i2 )
      (  V  [ o2 ]  = - o2 )
      (  V  [ u2 ]  = - u2 )

      ;; If there is a vowel before any consonant its a syl break
 
      (  V  [ b ]  = - b )
      (  V  [ ch ] = - ch )
      (  V  [ dh ] = - dh )
      (  V  [ d ]  = - d )
      (  V  [ f ]  = - f )
      (  V  [ gh ] = - gh )
      (  V  [ ng1 ] = - ng1 )
      (  V  [ ng ] = - ng )
      (  V  [ g ]  = - g )
      (  V  [ kh ] = - kh )
      (  V  [ sh ] = - sh )
      (  V  [ th ] = - th )
      (  V  [ h ]  = - h )
      (  V  [ j ]  = - j )
      (  V  [ k ]  = - k )
      (  V  [ l ]  = - l )
      (  V  [ m2 ] = - m2 )
      (  V  [ m1 ] = - m1 )
      (  V  [ m ]  = - m )
      (  V  [ ny ] = - ny )
      (  V  [ n2 ] = - n2 )
      (  V  [ n1 ] = - n1 )
      (  V  [ n ]  = - n )
      (  V  [ p ]  = - p )
      (  V  [ r ]  = - r )
      (  V  [ s ]  = - s )
      (  V  [ t ]  = - t )
      (  V  [ v ]  = - v )
      (  V  [ w ]  = - w )
      (  V  [ y ]  = - y )
      (  V  [ z ]  = - z )


      ;; If there is an n or m before any consonant except g, y, w its a syl break      
      ;; Consonant clusters are there for semi-vowels w and y are also dealt with 

      ( C   [ b ]  = - b )
      ( C   [ ch ]  = - ch )
      ( C   [ d ]  = - d )
      ( C   [ f ]  = - f )
      ( CG  [ g ]  = - g )
      ( CH  [ h ]  = - h )
      ( C   [ j ]  = - j )
      ( C   [ k ]  = - k )
      ( C   [ l ]  = - l )
      ( C   [ m2 ] = - m2 )
      ( C   [ m1 ] = - m1 )
      ( C   [ m ]  = - m )
      ( C   [ n2 ] = - n2 )
      ( C   [ n1 ] = - n1 )
      ( C   [ n ]  = - n )
      ( C   [ p ]  = - p )
      ( C   [ r ]  = - r )
      ( C   [ sh ]  = - sh )
      ( C   [ s ]  = - s )
      ( C   [ t ]  = - t )
      ( C   [ v ]  = - v )
      ( C   [ z ]  = - z )

      ;; Catch all Vowels and Consonants on their own (at begining of word)
      ;; and vowels not preceded by vowels are just written as it

      ( [ a ]  =    a )
      ( [ i ]  =    i )
      ( [ u ]  =    u )
      ( [ e ]  =    e )
      ( [ o ]  =    o )
      ( [ a1 ]  =  a1 )
      ( [ e1 ]  =  e1 )
      ( [ i1 ]  =  i1 )
      ( [ o1 ]  =  o1 )
      ( [ u1 ]  =  u1 )
      ( [ a2 ]  =  a2 )
      ( [ e2 ]  =  e2 )
      ( [ i2 ]  =  i2 )
      ( [ o2 ]  =  o2 )
      ( [ u2 ]  =  u2 )
      ( [ b ]  =  b )
      ( [ ch ] =  ch )
      ( [ dh ] =  dh )
      ( [ d ]  =  d )
      ( [ f ]  =  f )
      ( [ ng1 ] = ng1 )
      ( [ ng ] =  ng )
      ( [ gh ] =  gh )
      ( [ g ]  =  g )
      ( [ sh ] =  sh )
      ( [ th ] =  th )
      ( [ h ]  =  h )
      ( [ j ]  =  j )
      ( [ kh ] =  kh )
      ( [ k ]  =  k )
      ( [ l ]  =  l )
      ( [ m2 ] =  m2 )
      ( [ m1 ] =  m1 )
      ( [ ny ] =  ny )
      ( [ n2 ] =  n2 )
      ( [ n1 ] =  n1 )
      ( [ m ]  =  m )
      ( [ n ]  =  n )
      ( [ p ]  =  p )
      ( [ r ]  =  r )
      ( [ s ]  =  s )
      ( [ t ]  =  t )
      ( [ v ]  =  v )
      ( [ w ]  =  w )
      ( [ y ]  =  y )
      ( [ z ]  =  z )
 	
  )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  Stress assignment in unstress words by rewrite rules
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(lts.ruleset
 ;; Assign stress to a vowel when non-exists
 swahili.stress

 (
   (V a e i o u a1 e1 i1 o1 u1 a2 e2 i2 o2 u2)

   (UV a e i o u)

   (V1 a1 e1 i1 o1 u1)

   (V2 a2 e2 i2 o2 u2)

   (C b ch dh d f ng1 ng gh g kh sh th h j k l m2 m1 m ny n2 n1 n p r s t v w y z )

   (notNMC b ch dh d f ng1 ng gh g kh sh th h j k l ny p r s t v w y z )

   (VMN a e i o u m n)

   (SV y w)

  (VC a e i o u a1 e1 i1 o1 u1 a2 e2 i2 o2 u2 b ch dh d f ng1 ng gh g kh sh th h j k l m2 m1 m ny n2 n1 n p r s t v w y z )

  (ANY a e i o u a1 e1 i1 o1 u1 a2 e2 i2 o2 u2 b ch dh d f ng1 ng gh g kh sh th h j k l m2 m1 m ny n2 n1 n p r s t v w y z -)

  )

 (
  ;; consonants and minus nasal to themselves
  ( [ b ] = b )
  ( [ ch ] = ch )
  ( [ d ] = d )
  ( [ dh ] = dh )
  ( [ f ] = f )
  ( [ ng1 ] = ng1 )
  ( [ ng ] = ng )
  ( [ gh ] = gh )
  ( [ g ] = g )
  ( [ sh ] = sh )
  ( [ th ] = th )
  ( [ h ] = h )
  ( [ j ] = j )
  ( [ kh ] = kh )
  ( [ k ] = k )
  ( [ l ] = l )
  ( [ ny ] = ny )
  ( [ p ] = p )
  ( [ r ] = r )
  ( [ s ] = s )
  ( [ t ] = t )
  ( [ v ] = v )
  ( [ w ] = w )
  ( [ y ] = y )
  ( [ z ] = z )
  ( [ - ] = - )

  ;; stressed vowels and stressed nasal to themselves

  ( [ a1 ] = a1 )
  ( [ e1 ] = e1 )
  ( [ i1 ] = i1 )
  ( [ o1 ] = o1 )
  ( [ u1 ] = u1 )
  ( [ m1 ] = m1 )
  ( [ n1 ] = n1 )
  ( [ a2 ] = a2 )
  ( [ e2 ] = e2 )
  ( [ i2 ] = i2 )
  ( [ o2 ] = o2 )
  ( [ u2 ] = u2 )
  ( [ m2 ] = m2 )
  ( [ n2 ] = n2 )

  ;; last syllable is a vowel

  ( ANY * [ a ] - V # = a1 )
  ( ANY * [ e ] - V # = e1 )
  ( ANY * [ i ] - V # = i1 )
  ( ANY * [ o ] - V # = o1 )
  ( ANY * [ u ] - V # = u1 )

  ;; last syllable is a consonant followed by a vowel

  ( ANY * [ a ] - C V # = a1 )
  ( ANY * [ e ] - C V # = e1 )
  ( ANY * [ i ] - C V # = i1 )
  ( ANY * [ o ] - C V # = o1 )
  ( ANY * [ u ] - C V # = u1 )
  ( ANY * [ m ] - C V # = m1 )
  ( ANY * [ n ] - C V # = n1 )

  ;; last syllable is a consonant followed a semi-vowel then a vowel 

  ( ANY * [ a ] - C SV V # = a1 )
  ( ANY * [ e ] - C SV V # = e1 )
  ( ANY * [ i ] - C SV V # = i1 )
  ( ANY * [ o ] - C SV V # = o1 )
  ( ANY * [ u ] - C SV V # = u1 )
  ( ANY * [ m ] - C SV V # = m1 )
  ( ANY * [ n ] - C SV V # = n1 )

 ;; catch vowels nasals to themselves

  ( [ a ] = a )
  ( [ e ] = e )
  ( [ i ] = i )
  ( [ o ] = o )
  ( [ u ] = u )
  ( [ m ] = m )
  ( [ n ] = n )

 
))

(define (swahili_brackets phones)
   "(swahili_tosyl_brackets phones)
Takes a list of phones containing - as syllable boundary.  Construct the
Festival bracket structure."
 (let ((syl nil) (syls nil) (p phones) (stress 0))
    (while p
     (set! syl nil)
     (set! stress 0)
     (while (and p (not (eq? '- (car p))))
       (set! syl (cons (car p) syl))
       (if (string-matches (car p) ".*1")
           (set! stress 1))
       (set! p (cdr p)))
     (set! p (cdr p))  ;; skip the syllable separator
     (set! syls (cons (list (reverse syl) stress) syls)))
    (reverse syls)))   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Postlexical Rules 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (UON_swahili::postlex_rule1 utt)
  "(UON_swahili::postlex_rule1 utt)
A postlexical rule form correcting phenomena over word boundaries."
  (mapcar
   (lambda (s)
     ;; do something
     )
   (utt.relation.items utt 'Segment))
   utt)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon definition
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(lex.create "UON_swahili")
(lex.set.phoneset "UON_swahili")
;;(lex.set.lts.method 'UON_swahili_lts_function)
;;; If you have a compiled lexicon uncomment this
;(lex.set.compile.file (path-append UON_swahili_kw_dir "festvox/UON_swahili_lex.out"))
(UON_swahili_addenda)

;;; Lexicon

(lex.set.lts.method 'swahili_lts) 
(lex.set.lts.ruleset 'UON_swahili)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon setup
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (UON_swahili_kw::select_lexicon)
  "(UON_swahili_kw::select_lexicon)
Set up the lexicon for UON_swahili."
  (lex.select "UON_swahili")

  ;; Post lexical rules
  (set! postlex_rules_hooks (list UON_swahili::postlex_rule1))
)

(define (UON_swahili_kw::reset_lexicon)
  "(UON_swahili_kw::reset_lexicon)
Reset lexicon information."
  t
)

(set! swahili-backoff_rules
'(
(l! l)
(n! n)
(n @)
(i @)
(a @)
(e @)
(o @)
(u @)
(s z)
(_ #)

))

(provide 'UON_swahili_kw_lexicon)
